/*
** Copyright (C) 2002-2003 Ryan McCabe <ryan@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
*/

#ifndef __SNUFF_H
#define __SNUFF_H

#define SNUFF_AUTHOR	"Ryan McCabe <ryan@numb.org>"
#define SNUFF_VERSION	"1.0"

#define MSOCK_PATH			"/var/snuff/snuff"
#define STATE_FILE			"/var/snuff/.saved_state"
#define MAX_USERLEN			128
#define DEFAULT_USERLEN		8

typedef enum {
	false = 0,
	true = 1
} bool;

typedef enum {
	ACTION_NONE,
	ACTION_ADD,
	ACTION_DELETE,
	ACTION_DELETE_ALL,
	ACTION_LIST
} action_t;

typedef u_int32_t result_t;

struct alias_block {
	time_t expire;
	char username[MAX_USERLEN];
};

struct control_block {
	action_t action;
	time_t expire;
	char username[MAX_USERLEN];
};

#define RESULT_SUCCESS			0
#define RESULT_UNKNOWN			1
#define RESULT_FAIL				2
#define RESULT_TOOLONG			3
#define RESULT_NOTEXIST			4
#define RESULT_EXPIRESOON		5
#define RESULT_INVALID_ACTION	6
#define RESULT_NOALIASES		7
#define RESULT_TOOMANY			8

#ifdef ENABLE_DEBUGGING
#define debug(format, args...) do { \
	fprintf(stderr, "[" __FILE__ ":%d] " format "\n", __LINE__ , ##args); \
} while (0)
#else
#define debug(format, args...) do { } while (0)
#endif

#endif
