/*
** Copyright (C) 2002-2003 Ryan McCabe <ryan@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
*/

#ifndef __SNUFF_UTIL_H
#define __SNUFF_UTIL_H

char *xstrdup(const char *str);
void *xmalloc(size_t len);
void *xcalloc(size_t nmemb, size_t len);
char *xstrncpy(char *dest, const char *src, size_t n);
void xsleep(size_t seconds);

ssize_t sock_write(int sock, void *buf, size_t len);
ssize_t sock_read(int sock, void *buf, size_t len);

char *get_username(uid_t uid);
int find_user(const char *temp_user, uid_t *uid);
int find_group(const char *temp_group, gid_t *gid);
int drop_privs(uid_t new_uid, gid_t new_gid);
int go_background(void);

#endif
